%define debug 0

%define strip_bin 0
%define final 0

%define desktop_file 1
%define desktop_file_utils_version 0.2.93

%define qt_version 3.1.2

%define libtool 1

Name: kdenetwork
Version: 3.1.3
Release: 1.8
Summary: K Desktop Environment - Network Applications
Epoch: 7
Group: Applications/Internet
BuildRoot: %{_tmppath}/%{name}-buildroot
License: GPL

Source: ftp://ftp.kde.org/pub/kde/stable/%{version}/src/%{name}-%{version}.tar.bz2
Source1: kppp.pamd
Source2: ktalk
Source4: lisarc
Source5: lisa.redhat

Patch0: kdenetwork-3.1-desktop.patch
Patch1: kdenetwork-3.1-buildroot.patch
Patch2: kde-libtool.patch
Patch3: kdenetwork-3.1.3-kppp.patch
Patch4: kdenetwork-3.1.3-krfb.patch

# CAN-2005-0205, kppp Privileged FD Leak Vulnerability
Patch100: post-3.1.5-kdenetwork.diff

Requires: kdelibs >= 6:%{version}
Requires: kdebase >= 6:%{version}
%ifarch %{ix86} ppc ppc64 x86_64 ia64
Requires: kdepim  >= 6:%{version}
%endif
Requires: qt >= 1:%{qt_version}

Prereq: /sbin/chkconfig

BuildRequires: qt-devel >= %{qt_version}
BuildRequires: kdelibs-devel >= %{version}
BuildRequires: XFree86-devel
BuildRequires: libtool
BuildRequires: glibc-devel
BuildRequires: gcc-c++
BuildRequires: automake
BuildRequires: autoconf >= 2.53

%if %{desktop_file}
BuildRequires: desktop-file-utils >= %{desktop_file_utils_version}
%endif

Requires(post,postun): /sbin/ldconfig

Obsoletes: kdenetwork2
Obsoletes: %{name}-libs
Obsoletes: kdict
Obsoletes: kit
Obsoletes: kmail
Obsoletes: knewsticker
Obsoletes: knode
Obsoletes: korn
Obsoletes: kpf
Obsoletes: kppp
Obsoletes: kdenetwork-ppp
Obsoletes: ksirc
Obsoletes: ktalkd
Obsoletes: kxmlrpcd
Obsoletes: lisa

Provides: %{name}-libs
Provides: kdict
Provides: kit
Provides: kmail
Provides: knewsticker
Provides: knode
Provides: korn
Provides: kpf
Provides: kppp
Provides: ksirc
Provides: ktalkd
Provides: kxmlrpcd
Provides: lisa

%description
Networking applications for the K Desktop Environment.

%package devel
Summary: Development files for kdenetwork
Group: Development/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}

%description devel
Development files for kdenetwork. Install kdenetwork-devel if you wish
to develop or compile KDE networking applications.

%prep
%setup -q
%patch0 -p1 -b .dt
%patch1 -p1 -b .buildroot
%patch2 -p1 -b .libtool
%patch3 -p1 -b .kppp
%patch4 -p1 -b .krfb

# security fixes
%patch100 -p0 -b .CAN-2005-0205

# Workaround for legacy auto* tools
%if %{libtool}
[ -x /usr/bin/autoconf-2.5? ] && ln -s /usr/bin/autoconf-2.5? autoconf
[ -x /usr/bin/autoheader-2.5? ] && ln -s /usr/bin/autoheader-2.5? autoheader
[ -x /usr/bin/aclocal-1.5 ] && ln -s /usr/bin/aclocal-1.5 aclocal
[ -x /usr/bin/automake-1.5 ] && ln -s /usr/bin/automake-1.5 automake
export PATH=`pwd`:$PATH
make -f admin/Makefile.common cvs
%endif

%build
unset QTDIR || : ; . /etc/profile.d/qt.sh

FLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -fno-use-cxa-atexit -DNDEBUG -DNO_DEBUG"
export CFLAGS="$FLAGS $RPM_OPT_FLAGS"
export CXXFLAGS="$FLAGS $RPM_OPT_FLAGS"
export KDEDIR=%{_prefix}

%configure \
   --with-qt-libraries=$QTDIR/lib \
   --includedir=%{_includedir}/kde

# ld breaks with -fPIC on ppc, workaround
# it will be removed when this bug is fixed
%ifarch ppc ppc64
perl -pi -e 's,^pic_flag=" -fPIC -DPIC",pic_flag=" -fpic",g' libtool
%endif

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/etc/pam.d
cp %{SOURCE1} $RPM_BUILD_ROOT/etc/pam.d/kppp

# Make symlinks relative
mkdir -p $RPM_BUILD_ROOT%{_docdir}/HTML/en/common
pushd $RPM_BUILD_ROOT%{_docdir}/HTML/en
for i in *; do
   [ -d $i -a -L $i/common ] && ln -nfs ../common $i
done
popd

# Run kppp through consolehelper
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mv $RPM_BUILD_ROOT%{_bindir}/kppp $RPM_BUILD_ROOT%{_sbindir}
ln -s consolehelper $RPM_BUILD_ROOT%{_bindir}/kppp
mkdir -p $RPM_BUILD_ROOT/etc/security/console.apps
cat >$RPM_BUILD_ROOT/etc/security/console.apps/kppp <<EOF
USER=root
PROGRAM=%{_sbindir}/kppp
SESSION=true
EOF

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/xinetd.d
cp %{SOURCE2} $RPM_BUILD_ROOT/%{_sysconfdir}/xinetd.d

# move desktop files back
pushd $RPM_BUILD_ROOT%{_datadir}/applnk
for i in `find . -name "More"`; do
   if /bin/ls $i/*.desktop >& /dev/null ; then
      pushd $i
      for j in *.desktop ; do
         grep "Hidden=true" $j >& /dev/null || mv -f $j ..
      done
      popd
   fi
done
popd

# Add lisa startup script
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/lisarc
install -m 0755 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/lisa

%if %{desktop_file}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications

desktop-file-install --vendor kde \
   --dir $RPM_BUILD_ROOT%{_datadir}/applications \
   --add-category "Application;Network;X-Red-Hat-Extra" \
   --delete-original \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/ksirc.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/kit.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/knewsticker-standalone.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/KMail.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/Kppp.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/kppplogview.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/KNode.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/KOrn.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/kget.desktop \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Internet/krdc.desktop

desktop-file-install --vendor kde \
   --dir $RPM_BUILD_ROOT%{_datadir}/applications \
   --add-category "Application;Utility;X-Red-Hat-Extra" \
   --delete-original \
   $RPM_BUILD_ROOT%{_datadir}/applnk/Utilities/kmailcvt.desktop

desktop-file-install --vendor kde \
   --dir $RPM_BUILD_ROOT%{_datadir}/applications \
   --add-category "Application;System;X-Red-Hat-Extra" \
   --delete-original \
   $RPM_BUILD_ROOT%{_datadir}/applnk/System/krfb.desktop

rm -f $RPM_BUILD_ROOT%{_datadir}/applnk/Settings/Personalization/kcmnewsticker.desktop

for i in Accessibility Components FileBrowsing Information LookNFeel Network \
   Peripherals Personalization PowerControl Sound WebBrowsing Security \
   Desktop LookNFeel/Desktop LookNFeel/Themes LookNFeel/Windows System; do
   case $i in
      Accessibility) catagory="X-KDE-Accessibility";;
      FileBrowsing) catagory="X-KDE-FileBrowsing";;
      Databases) catagory="X-KDE-Database";;
      Desktop) catagory="X-KDE-Desktop";;
      Help) catagory="X-KDE-Help";;
      Information) catagory="X-KDE-Information";;
      LookNFeel) catagory="X-KDE-LookNFeel";;
      LookNFeel/Desktop) catagory="X-KDE-LookNFeel-Desktop";;
      LookNFeel/Themes) catagory="X-KDE-LookNFeel-Theme";;
      LookNFeel/Windows) catagory="X-KDE-LookNFeel-Window";;
      Network) catagory="X-KDE-Network";;
      Peripherals) catagory="X-KDE-Peripherals";;
      Personalization) catagory="X-KDE-Personalization";;
      Components) catagory="X-KDE-Components";;
      Security) catagory="X-KDE-Security";;
      PowerControl) catagory="X-KDE-PowerControl";;
      Sound) catagory="X-KDE-Sound";;
      System) catagory="X-KDE-System";;
      WebBrowsing) catagory="X-KDE-WebBrowsing";;
   esac
   if /bin/ls $RPM_BUILD_ROOT%{_datadir}/applnk/Settings/$i/*.desktop >& /dev/null ; then
     desktop-file-install --vendor kde \
       --delete-original \
       --dir $RPM_BUILD_ROOT%{_datadir}/applications \
       --add-category "$catagory" \
       --add-only-show-in KDE \
       $RPM_BUILD_ROOT%{_datadir}/applnk/Settings/$i/*.desktop
   fi
done

desktop-file-install --vendor kde \
       --delete-original \
       --dir $RPM_BUILD_ROOT%{_datadir}/applications \
       --add-category "X-KDE-Hidden" \
       --add-only-show-in KDE \
       $RPM_BUILD_ROOT%{_datadir}/applnk/.hidden/*.desktop

for i in Internet Utilities ; do
   case "$i" in
      Internet) d="Network" ;;
      Utilities) d="Utility" ;;
      *) d=$i ;;
   esac
   if /bin/ls $RPM_BUILD_ROOT%{_datadir}/applnk/$i/*.desktop >& /dev/null ; then
     desktop-file-install --vendor kde \
       --delete-original \
       --dir $RPM_BUILD_ROOT%{_datadir}/applications \
       --add-category "Application;$d;X-Red-Hat-Base" \
       --add-only-show-in KDE \
       $RPM_BUILD_ROOT%{_datadir}/applnk/$i/*.desktop
   fi
done

rm -rfv $RPM_BUILD_ROOT%{_datadir}/applnk
%endif

%post
/sbin/chkconfig --add lisa

%preun
if [ "$1" = "0" ]; then
    /sbin/chkconfig --del lisa
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%config /etc/security/console.apps/kppp
%config /etc/pam.d/kppp
%config %{_sysconfdir}/lisarc
%config %{_sysconfdir}/rc.d/init.d/lisa
%config %{_sysconfdir}/xinetd.d/ktalk
%doc %{_docdir}/HTML/en/*
%{_libdir}/ksirc*.so
%{_libdir}/kde3/*.la
%{_libdir}/*.la
%{_libdir}/kxmlrpcd*.so
%{_libdir}/libkdenetwork*.so.*
%{_libdir}/libkntsrcfilepropsdlg*.so
%{_libdir}/libmimelib*.so.*
%{_libdir}/kde3/*.so
%{_bindir}/dsirc
%{_bindir}/kdict
%{_bindir}/kget
%{_bindir}/kgpgcertmanager
%{_bindir}/kit
%{_bindir}/kmail
%{_bindir}/kmailcvt
%{_bindir}/knewstickerstub
%{_bindir}/knode
%{_bindir}/korn
%{_bindir}/kppplogview
%{_bindir}/krdc
%{_bindir}/krfb
%{_bindir}/ksirc
%{_bindir}/ktalkd
%{_bindir}/ktalkdlg
%{_bindir}/kxmlrpcd
%{_bindir}/lisa
%{_bindir}/mail.local
%{_bindir}/reslisa
%{_bindir}/kppp
%{_sbindir}/kppp
%{_datadir}/apps/*
%{_datadir}/services/*
%{_datadir}/icons/*/*/*/*
%{_datadir}/sounds/*
%{_datadir}/config/*
%{_datadir}/mimelnk/*
%{_datadir}/servicetypes/*
%if %{desktop_file}
%{_datadir}/applications/*.desktop
%else
%{_datadir}/applnk
%endif

%files devel
%defattr(-,root,root)
%{_includedir}/kde/*.h
%{_includedir}/kde/mimelib

%changelog
* Wed Feb 16 2005 Than Ngo <than@redhat.com> 7:3.1.3-1.8
- Apply patch to fix kppp privileged fd leak vulnerability, CAN-2005-0205

* Mon Dec 20 2004 Than Ngo <than@redhat.com> 7:3.1.3-1.7
- add workaround for rpm bug

* Wed Nov 10 2004 Than Ngo <than@redhat.com> 7:3.1.3-1.6
- fix krfb crash #136215

* Tue Sep 16 2003 Than Ngo <than@redhat.com> 7:3.1.3-1.5
- rebuilt

* Mon Sep 08 2003 Than Ngo <than@redhat.com> 7:3.1.3-1.4
- use ifarch instead ifnarch

* Thu Sep 04 2003 Than Ngo <than@redhat.com> 7:3.1.3-1.3
- fixed requirement problem

* Wed Sep 03 2003 Than Ngo <than@redhat.com> 7:3.1.3-1.2
- Fixed locking problem by start of kppp (bug #102513)
- Added more Requires (bug #101610, #74567)

* Thu Aug 28 2003 Than Ngo <than@redhat.com> 7:3.1.3-1.1
- rebuilt

* Tue Aug 05 2003 Than Ngo <than@redhat.com> 7:3.1.3-1
- 3.1.3

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Mon May 19 2003 Than Ngo <than@redhat.com> 3.1.2-2
- 3.1.2

* Wed Apr 30 2003 Than Ngo <than@redhat.com> 3.1.1-2
- build with -fpic on ppc (ld bugs)

* Wed Mar 19 2003 Than Ngo <than@redhat.com> 3.1.1-1
- 3.1.1

* Fri Mar 7 2003 Dan Walsh <dwalsh@redhat.com> 3.1-8
- bump release number 

* Thu Mar  6 2003 Than Ngo <than@redhat.com> 3.1-7
- la file issue, bug #85727

* Wed Feb 26 2003 Dan Walsh <dwalsh@redhat.com> 3.1-6
- Fix service description

* Mon Feb 24 2003 Elliot Lee <sopwith@redhat.com>
- debuginfo rebuild

* Fri Feb 21 2003 Than Ngo <than@redhat.com> 3.1-4
- get rid of gcc path from dependency_libs

* Fri Feb 14 2003 Than Ngo <than@redhat.com> 3.1-3
- add patch to start lisa daemon correct from initscript, #84257
- dependency issue, #81430

* Wed Jan 29 2003 Than Ngo <than@redhat.com> 3.1-2
- get rid of kotalkd, bug #82765
- lisa initscript, bug #82935

* Tue Jan 28 2003 Than Ngo <than@redhat.com> 3.1-1
- 3.1 release
- remove some unneeded macros
 
* Thu Jan 23 2003 Tim Powers <timp@redhat.com> 7:3.1-0.10
- rebuild

* Sun Jan 12 2003 Thomas Woerner <twoerner@redhat.com> 3.1-0.9
- rc6
- exclude ia64

* Sun Dec 29 2002 Than Ngo <than@redhat.com> 3.1-0.8
- fix bug #80354

* Mon Dec 16 2002 Tim Powers <timp@redhat.com> 3.1-0.7
- rebuild

* Fri Dec 13 2002 Than Ngo <than@redhat.com> 3.1-0.6
- fix rpm conflicts

* Tue Dec 10 2002 Than Ngo <than@redhat.com> 3.1-0.5
- fix to build on s390/s390x

* Mon Dec  9 2002 Than Ngo <than@redhat.com> 3.1-0.4
- fix bug #78650
- desktop file issues

* Sun Dec  8 2002 Than Ngo <than@redhat.com> 3.1-0.3
- Add lisa startup script (bug #72114)
- fix dependency issue

* Thu Nov 28 2002 Than Ngo <than@redhat.com> 3.1-0.2
- add obsoletes/provides sub packages

* Tue Nov 26 2002 Than Ngo <than@redhat.com> 3.1-0.1
- update to 3.1 rc4
- remove sub packages

* Tue Nov 12 2002 Than Ngo <than@redhat.com> 3.0.5-3
- respin

* Mon Nov 11 2002 Nalin Dahyabhai <nalin@redhat.com> 3.0.5-2
- remove directory names from the PAM configuration, allowing the same config
  file to be used for all arches on multilib systems

* Sat Nov  9 2002 Than Ngo <than@redhat.com> 3.0.5-1
- update to 3.0.5

* Tue Oct 15 2002 Than Ngo <than@redhat.com> 3.0.4-1
- 3.0.4

* Sat Oct 12 2002 Than Ngo <than@redhat.com> 3.0.3-3.1
- kpf Directory traversal

* Sat Aug 24 2002 Than Ngo <than@redhat.com> 3.0.3-3
- move knode menu entries to Extras (bug #71881)

* Wed Aug 21 2002 Preston Brown <pbrown@redhat.com> 3.0.3-2
- buildrequirement on automake15, autoconf >= 2.53
- move kmail, kppp, kppplogview menu entries to Extras

* Mon Aug 12 2002 Than Ngo <than@redhat.com> 3.0.3-1
- 3.0.3
- build using gcc-3.2-0.3

* Mon Aug  5 2002 Than Ngo <than@redhat.com> 3.0.2-4
- desktop file issues
- Added more BuildRequires (bug #70056)
- Added support timestamp
- Added Node.desktop in correct package (bug #65087)
- Fixed dangling symlink (bug #63876)

* Tue Jul 23 2002 Tim Powers <timp@redhat.com> 3.0.2-3
- build using gcc-3.2-0.1

* Sat Jul 20 2002 Than Ngo <than@redhat.com> 3.0.2-2
- fix desktop files issue

* Thu Jul 11 2002 Than Ngo <than@redhat.com> 3.0.2-1
- 3.0.2
- use desktop-file-install

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon May 13 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.1-1
- 3.0.1

* Wed Apr 17 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-4
- Fix dangling symlink introduced by library renaming

* Tue Apr 16 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-3
- Rename libraries
- Fix default kmail settings

* Wed Apr  3 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-2
- Merge fixes for 3 potential kmail crashes from KDE_3_0_BRANCH

* Wed Mar 27 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-1
- 3.0 final

* Wed Mar  6 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20020306.1
- Rename subpackages

* Thu Jan 31 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20020129.2
- Rebuild with new kdelibs

* Tue Jan 29 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20020129.1
- Update

* Tue Jan  8 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20020108.1
- Update
- Integrate ktalk stuff with xinetd

* Tue Dec 18 2001 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20011218.1
- Update
- Split into subpackages

* Sun Jul 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010722.1
- Update
- Add build dependencies
- Work around ia64 breakages

* Sun May 13 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010513.1
- Update to CVS
- clean up specfile
- Use %%post -p and %%postun -p

* Wed Feb 21 2001 Than Ngo <than@redhat.com>
- 2.1-respin

* Mon Feb 19 2001 Than Ngo <than@redhat.com>
- update 2.1
- fix dangling symlinks

* Fri Feb  2 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Limit CPU usage to 2 CPUs to make asok happy

* Mon Jan 22 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update
- Don't require perl, not everyone using ksirc is also using
  ksirc perl scripting...

* Mon Jan  8 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update (needed because of kdelibs change)
- Obsolete kdenetwork2 (from 7.0 preview)

* Mon Jan  1 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update

* Tue Dec 12 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add missing PAM file, fix group

* Wed Nov 15 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- update to HEAD 

* Fri Nov  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update CVS (fix kmail segfault with empty identity)

* Tue Oct 31 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix up consolehelper config

* Mon Oct 30 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to current KDE_2_0_BRANCH (this should fix up knode)
- Run kppp through consolehelper (Bug #20021)
- Split of kppp and kppplog to a separate package, kdenetwork-ppp
  (RFE #20022)

* Mon Oct 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0 final

* Wed Oct  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0

* Thu Aug 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.93

* Mon Aug  7 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new version

* Tue Jul 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- disable keystone for now (compiler problem)

* Fri Jul 21 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- some fixes to spec file

* Tue Jul 18 2000 Than Ngo <than@redhat.de>
- rebuilt with glibc-2.1.92-14 and gcc-2.96-40

* Thu Jul 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Obsolete ktalk (powertools 6.x)
- SMPify

* Tue Jul 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- use gcc 2.96
- new snapshot

* Fri Jun 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Epoch

* Tue Jun 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- ExcludeArch ia64 for now

* Sat Mar 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- move it to /usr, where it belongs

* Mon Oct 25 1999 Bernhard Rosenkraenzer <bero@redhat.de>
- initial RPM
